We designed open-source Collective Knowledge framework (CK)
to enable automated, collaborative, systematic and reproducible
research: http://cKnowledge.org .

CK is a small, modular, customizable, portable and CLI-based
tool helping the community develop, share and reuse common APIs
and JSON meta descriptions for ad-hoc software, hardware, data,
and models. 

Such reusable APIs help researchers and workgroups
automate all their tedious and repetitive tasks such
as detecting software and hardware dependencies; installing
missing packages; downloading data sets and models; compiling
and running programs; assembling and running pipelines
(workflows) for model/software/hardware benchmarking, autotuning
and co-design; crowdsourcing time-consuming experiments across
computing resources provided by volunteers similar to SETI@home;
reproducing and visualizing results; enabling fair comparison
of numerous published techniques; automatically generating
interactive articles and reproducible papers with reusable
research pipelines and components, and so on.

* Real world use cases: http://cKnowledge.org/partners
* FOSDEM'19 presentation: https://doi.org/10.5281/zenodo.2556147
* Reproducible papers: http://cTuning.org/ae
* Development: https://github.com/ctuning/ck
